Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.8.2 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire.muc.spi
Class MUCPersistenceManager

    java.lang.Object
      org.jivesoftware.openfire.muc.spi.MUCPersistenceManager

    public class MUCPersistenceManager

extends Object

A manager responsible for ensuring room persistence. There are different ways to make a room persistent. The first attempt will be to save the room in a relation database. If for some reason the room can't be saved in the database an alternative repository will be used to save the room such as XML files.

After the problem with the database has been solved, the information saved in the XML files will be moved to the database.

Author:
  Gaston Dombiak

Constructor Summary
`MUCPersistenceManager()`

Method Summary
`static void` | `deleteFromDB(MUCRoom room)` Removes the room configuration and its affiliates from the database.
`static void` | `deleteLocalProperty(String subdomain, String name)`
`static void` | `deleteProperty(String subdomain, String name)` Deletes a Jive property.
`static boolean` | `getBooleanProperty(String subdomain, String name)` Returns a boolean value Jive property.
`static boolean` | `getBooleanProperty(String subdomain, String name, boolean defaultValue)` Returns a boolean value Jive property.
`static int` | `getIntProperty(String subdomain, String name, int defaultValue)` Returns an integer value Jive property.
`static long` | `getLongProperty(String subdomain, String name, long defaultValue)` Returns a long value Jive property.
`static List<String>` | `getProperties(String subdomain, String parent)` Return all immediate children property values of a parent Jive property as a list of strings, or an empty list if there are no children.
`static String` | `getProperty(String subdomain, String name)` Returns a Jive property.
`static String` | `getProperty(String subdomain, String name, String defaultValue)` Returns a Jive property.
`static List<String>` | `getPropertyNames(String subdomain)` Returns all MUC service property names.
`static List<String>` | `getPropertyNames(String subdomain, String parent)` Return all immediate children property names of a parent Jive property as a list of strings, or an empty list if there are no children.
`static String` | `getReservedNickname(MUCRoom room, String bareJID)` Returns the reserved room nickname for the bare JID in a given room or null if none.
`static void` | `loadFromDB(LocalMUCRoom room)` Loads the room configuration from the database if the room was persistent.
`static Collection<LocalMUCRoom>` | `loadRoomsFromDB(MultiUserChatService chatserver, Date emptyDate, PacketRouter packetRouter)` Loads all the rooms that had occupants after a given date from the database.
`static void` | `refreshProperties(String subdomain)` Resets (reloads) the properties for a specified subdomain.
`static void` | `removeAffiliationFromDB(org.xmpp.packet.JID bareJID)` Removes the affiliation of the user from the DB if ANY room that is persistent.
`static void` | `removeAffiliationFromDB(MUCRoom room, org.xmpp.packet.JID jid, MUCRole.Affiliation oldAffiliation)` Removes the affiliation of the user from the DB if the room is persistent.
`static void` | `saveAffiliationToDB(MUCRoom room, org.xmpp.packet.JID jid, String nickname, MUCRole.Affiliation newAffiliation, MUCRole.Affiliation oldAffiliation)` Update the DB with the new affiliation of the user in the room.
`static boolean` | `saveConversationLogEntry(org.jivesoftware.openfire.muc.spi.ConversationLogEntry entry)` Saves the conversation log entry to the database.
`static void` | `saveToDB(LocalMUCRoom room)` Save the room configuration to the DB.
`static void` | `setLocalProperty(String subdomain, String name, String value)`
`static void` | `setProperties(String subdomain, Map<String,String> propertyMap)` Sets multiple Jive properties at once.
`static void` | `setProperty(String subdomain, String name, String value)` Sets a Jive property.
`static void` | `updateRoomEmptyDate(MUCRoom room)` Updates the room's lock status in the database.
`static void` | `updateRoomLock(LocalMUCRoom room)` Updates the room's lock status in the database.
`static void` | `updateRoomSubject(MUCRoom room)` Updates the room's subject in the database.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MUCPersistenceManager

    public MUCPersistenceManager()

Method Detail

### getReservedNickname

    public static String getReservedNickname(MUCRoom room,
                                             String bareJID)

  Returns the reserved room nickname for the bare JID in a given room or null if none.

  Parameters:
    `room` - the room where the user would like to obtain his reserved nickname.
    `bareJID` - The bare jid of the user of which you'd like to obtain his reserved nickname.
  Returns:
    the reserved room nickname for the bare JID or null if none.

### loadFromDB

    public static void loadFromDB(LocalMUCRoom room)

  Loads the room configuration from the database if the room was persistent.

  Parameters:
    `room` - the room to load from the database if persistent

### saveToDB

    public static void saveToDB(LocalMUCRoom room)

  Save the room configuration to the DB.

  Parameters:
    `room` - The room to save its configuration.

### deleteFromDB

    public static void deleteFromDB(MUCRoom room)

  Removes the room configuration and its affiliates from the database.

  Parameters:
    `room` - the room to remove from the database.

### loadRoomsFromDB

    public static Collection<LocalMUCRoom> loadRoomsFromDB(MultiUserChatService chatserver,
                                                           Date emptyDate,
                                                           PacketRouter packetRouter)

  Loads all the rooms that had occupants after a given date from the database. This query will be executed only when the service is starting up.

  Parameters:
    `chatserver` - the chat server that will hold the loaded rooms.
    `emptyDate` - rooms that hadn't been used before this date won't be loaded.
    `packetRouter` - the PacketRouter that loaded rooms will use to send packets.
  Returns:
    a collection with all the persistent rooms.

### updateRoomSubject

    public static void updateRoomSubject(MUCRoom room)

  Updates the room's subject in the database.

  Parameters:
    `room` - the room to update its subject in the database.

### updateRoomLock

    public static void updateRoomLock(LocalMUCRoom room)

  Updates the room's lock status in the database.

  Parameters:
    `room` - the room to update its lock status in the database.

### updateRoomEmptyDate

    public static void updateRoomEmptyDate(MUCRoom room)

  Updates the room's lock status in the database.

  Parameters:
    `room` - the room to update its lock status in the database.

### saveAffiliationToDB

    public static void saveAffiliationToDB(MUCRoom room,
                                           org.xmpp.packet.JID jid,
                                           String nickname,
                                           MUCRole.Affiliation newAffiliation,
                                           MUCRole.Affiliation oldAffiliation)

  Update the DB with the new affiliation of the user in the room. The new information will be saved only if the room is_persistent and has already been saved to the database previously.

  Parameters:
    `room` - The room where the affiliation of the user was updated.
    `jid` - The bareJID of the user to update this affiliation.
    `nickname` - The reserved nickname of the user in the room or null if none.
    `newAffiliation` - the new affiliation of the user in the room.
    `oldAffiliation` - the previous affiliation of the user in the room.

### removeAffiliationFromDB

    public static void removeAffiliationFromDB(MUCRoom room,
                                               org.xmpp.packet.JID jid,
                                               MUCRole.Affiliation oldAffiliation)

  Removes the affiliation of the user from the DB if the room is persistent.

  Parameters:
    `room` - The room where the affiliation of the user was removed.
    `jid` - The bareJID of the user to remove his affiliation.
    `oldAffiliation` - the previous affiliation of the user in the room.

### removeAffiliationFromDB

    public static void removeAffiliationFromDB(org.xmpp.packet.JID bareJID)

  Removes the affiliation of the user from the DB if ANY room that is persistent.

  Parameters:
    `bareJID` - The bareJID of the user to remove his affiliation from ALL persistent rooms.

### saveConversationLogEntry

    public static boolean saveConversationLogEntry(org.jivesoftware.openfire.muc.spi.ConversationLogEntry entry)

  Saves the conversation log entry to the database.

  Parameters:
    `entry` - the ConversationLogEntry to save to the database.
  Returns:
    true if the ConversationLogEntry was saved successfully to the database.

### getProperty

    public static String getProperty(String subdomain,
                                     String name)

  Returns a Jive property.

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
    `name` - the name of the property to return.
  Returns:
    the property value specified by name.

### getProperty

    public static String getProperty(String subdomain,
                                     String name,
                                     String defaultValue)

  Returns a Jive property. If the specified property doesn't exist, the `defaultValue` will be returned.

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
    `name` - the name of the property to return.
    `defaultValue` - value returned if the property doesn't exist.
  Returns:
    the property value specified by name.

### getIntProperty

    public static int getIntProperty(String subdomain,
                                     String name,
                                     int defaultValue)

  Returns an integer value Jive property. If the specified property doesn't exist, the `defaultValue` will be returned.

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
    `name` - the name of the property to return.
    `defaultValue` - value returned if the property doesn't exist or was not a number.
  Returns:
    the property value specified by name or `defaultValue`.

### getLongProperty

    public static long getLongProperty(String subdomain,
                                       String name,
                                       long defaultValue)

  Returns a long value Jive property. If the specified property doesn't exist, the `defaultValue` will be returned.

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
    `name` - the name of the property to return.
    `defaultValue` - value returned if the property doesn't exist or was not a number.
  Returns:
    the property value specified by name or `defaultValue`.

### getBooleanProperty

    public static boolean getBooleanProperty(String subdomain,
                                             String name)

  Returns a boolean value Jive property.

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
    `name` - the name of the property to return.
  Returns:
    true if the property value exists and is set to `"true"` (ignoring case). Otherwise `false` is returned.

### getBooleanProperty

    public static boolean getBooleanProperty(String subdomain,
                                             String name,
                                             boolean defaultValue)

  Returns a boolean value Jive property. If the property doesn't exist, the `defaultValue` will be returned. If the specified property can't be found, or if the value is not a number, the `defaultValue` will be returned.

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
    `name` - the name of the property to return.
    `defaultValue` - value returned if the property doesn't exist.
  Returns:
    true if the property value exists and is set to `"true"` (ignoring case). Otherwise `false` is returned.

### getPropertyNames

    public static List<String> getPropertyNames(String subdomain,
                                                String parent)

  Return all immediate children property names of a parent Jive property as a list of strings, or an empty list if there are no children. For example, given the properties `X.Y.A`, `X.Y.B`, `X.Y.C` and `X.Y.C.D`, then the immediate child properties of `X.Y` are `A`, `B`, and `C` (`C.D` would not be returned using this method).

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
    `parent` - the root "node" of the properties to retrieve
  Returns:
    a List of all immediate children property names (Strings).

### getProperties

    public static List<String> getProperties(String subdomain,
                                             String parent)

  Return all immediate children property values of a parent Jive property as a list of strings, or an empty list if there are no children. For example, given the properties `X.Y.A`, `X.Y.B`, `X.Y.C` and `X.Y.C.D`, then the immediate child properties of `X.Y` are `X.Y.A`, `X.Y.B`, and `X.Y.C` (the value of `X.Y.C.D` would not be returned using this method).

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
    `parent` - the name of the parent property to return the children for.
  Returns:
    all child property values for the given parent.

### getPropertyNames

    public static List<String> getPropertyNames(String subdomain)

  Returns all MUC service property names.

  Parameters:
    `subdomain` - the subdomain of the service to retrieve a property from
  Returns:
    a List of all property names (Strings).

### setProperty

    public static void setProperty(String subdomain,
                                   String name,
                                   String value)

  Sets a Jive property. If the property doesn't already exists, a new one will be created.

  Parameters:
    `subdomain` - the subdomain of the service to set a property for
    `name` - the name of the property being set.
    `value` - the value of the property being set.

### setLocalProperty

    public static void setLocalProperty(String subdomain,
                                        String name,
                                        String value)

### setProperties

    public static void setProperties(String subdomain,
                                     Map<String,String> propertyMap)

  Sets multiple Jive properties at once. If a property doesn't already exists, a new one will be created.

  Parameters:
    `subdomain` - the subdomain of the service to set properties for
    `propertyMap` - a map of properties, keyed on property name.

### deleteProperty

    public static void deleteProperty(String subdomain,
                                      String name)

  Deletes a Jive property. If the property doesn't exist, the method does nothing. All children of the property will be deleted as well.

  Parameters:
    `subdomain` - the subdomain of the service to delete a property from
    `name` - the name of the property to delete.

### deleteLocalProperty

    public static void deleteLocalProperty(String subdomain,
                                           String name)

### refreshProperties

    public static void refreshProperties(String subdomain)

  Resets (reloads) the properties for a specified subdomain.

  Parameters:
    `subdomain` - the subdomain of the service to reload properties for.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.8.2 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.